from __future__ import division
from pylab import *

# Program to read outputs of case stude 1 using the MESA stellar evolution code
# Comment / uncomment plots according to what you want to visualize

# Reading history.data MESA output file

history=loadtxt('history.data',skiprows=7)
model_number = history[:,0]
star_age = history[:,1]
star_mass = history[:,2]
log_Teff = history[:,3]
log_L = history[:,4]
log_R = history[:,5]
log_center_T = history[:,6]
log_center_Rho = history[:,7]
log_center_P = history[:,8]
log_Lnuc = history[:,9]
log_abs_Lgrav = history[:,10]
center_h1 = history[:,11]
center_he4 = history[:,12]
center_c12 = history[:,13]
center_n14 = history[:,14]
center_o16 = history[:,15]
center_ne20= history[:,16]
surf_h1 = history[:,17]
surf_he4 = history[:,18]
surf_c12 = history[:,19]
surf_n14 = history[:,20]
surf_o16 = history[:,21]
surf_ne20 = history[:,22]
pp = history[:,23]
cno = history[:,24]
trialpha = history[:,25]
burn_c = history[:,26]
# Luminosities plot
Lnuc,Lgrav=semilogx(star_age,log_Lnuc,star_age,log_abs_Lgrav)
xlabel('log age (years)')
ylabel('Lnuc,Lgrav')
legend((Lnuc,Lgrav),('Lnuc','Lgrav'), 'lower right')
title('Gravitaitonal versus nuclear luminosities')
show()

# Core Abundances plot

H,He4,C12,N14,O16,Ne20=semilogx(star_age,center_h1,star_age,center_he4,star_age,center_c12,star_age,center_n14,star_age,center_o16,star_age,center_ne20)
xlim(1,6e6)
ylim(-8,0)
xlabel('log age (years)')
ylabel('Log10 of central mass fractions')
legend((H,He4,C12,N14,O16,Ne20),('H','He4','C12','N14','O16','Ne20'), 'lower right')
title('Evolution of central mass fractions')
show()

# Surface abundances
H,He4,C12,N14,O16,Ne20=semilogx(star_age,surf_h1,star_age,surf_he4,star_age,surf_c12,star_age,surf_n14,star_age,surf_o16,star_age,surf_ne20)
xlim(1,6e6)
ylim(-8,0)
xlabel('log age (years)')
ylabel('Log10 of surface mass fractions')
legend((H,He4,C12,N14,O16,Ne20),('H','He4','C12','N14','O16','Ne20'), 'lower right')
title('Evolution of surface mass fractions')
show()


# Nuclear energy plot
pp,cno,trialpha,burn_c=semilogx(star_age,pp,star_age,cno,star_age,trialpha,star_age_burn_c)
xlim(1,6e6)
ylim(-40,0.5)
xlabel('log age (years)')
ylabel('Energy generation from different sources')
legend((pp,cno,trialpha,burn_c),('pp','CNO','triple alpha', 'C burning'), 'lower right')
title('Evolution of the energy generation from H burning to C burning')
show()


# Reading MESA profiles output files
prof=open('profiles.index','r')
l=prof.readline()
models=l.split()
mod=models[0]
prof.close()

for i in range(1,int(mod)+1):
    print 'profile' + str(i) + '.data'
    profile=loadtxt('profile' + str(i) + '.data',skiprows=6)
    n=profile[:,0]
    q=profile[:,1]
    logR=profile[:,2]
    logT=profile[:,3]
    logrho=profile[:,4]
    logP=profile[:,5]
    logh=profile[:,6]
    loghe4=profile[:,7]
    logc12=profile[:,8]
    logn14=profile[:,9]
    logo16=profile[:,10]
    logne20=profile[:,11]
    logkap=profile[:,12]
    logtau=profile[:,13]

    # Evolution of the internal profiles

    H,He4,C12,N14,O16,Ne20=semilogy(logR,logh,logR,loghe4,logR,logc12,logR,logn14,logR,logo16,logR,logne20)
    xlim(-3,3)
    xlabel('log r/R')
    ylabel('log Mass fraction')
    legend((H,He4,C12,N14,O16,Ne20),('H','He','C12','N14','O16','Ne20'),'lower left')
    show()
